print("What's this? Japan and France are Evolving!")

include("FLuaVector.lua")

local eCivilizationJapan = GameInfoTypes.CIVILIZATION_JAPAN
local eCivilizationFrance = GameInfoTypes.CIVILIZATION_FRANCE
--[[
function WholesomeJapan(iFromPlayer, iFromCity, iToPlayer, iToCity, iDomain, iConnectionType)
    local pFromPlayer = Players[iFromPlayer]
    local pToPlayer = Players[iToPlayer]
    if pToPlayer:GetCivilizationType() == eCivilizationJapan then --Are you trying to trade with Japan?
        for _,v in ipairs(pToPlayer:GetTradeRoutes()) do --List all Japan's Trade Routes
            if (v.ToCivilizationType == pFromPlayer:GetCivilizationType()) then 
                return true ----Oh we did trade with you.. mkay. You can trade with us here.
            end
        end
        return false --I've never heard of you be GONE
    end
    return true --default return rue
end
]]--

-- adds GPP and yields for every TR
function TradeRoutesSakokuBonus(iPlayer)
	local pPlayer = Players[iPlayer]

	if (pPlayer and pPlayer:GetCivilizationType() == eCivilizationJapan) then -- see if it's Japan's turn

		local iNumUnusedTRs = pPlayer:GetNumInternationalTradeRoutesAvailable() - (pPlayer:GetNumInternalTradeRoutes() + pPlayer:GetNumInternationalTradeRoutes())
		local eSakokuDummy = GameInfoTypes.BUILDING_SAKOKU_DUMMY
		local pCapital = pPlayer:GetCapitalCity()
	
		pCapital:SetNumRealBuilding(eSakokuDummy, iNumUnusedTRs)
	end
end

if Game.IsCivEverActive(eCivilizationJapan) then
--	GameEvents.PlayerCanCreateTradeRoute.Add(WholesomeJapan)
	GameEvents.PlayerDoTurn.Add(TradeRoutesSakokuBonus)
end

function EspritDeCorpsYieldsBonus(iAttackingPlayer, iAttackingUnit, attackerDamage, attackerFinalDamage, attackerMaxHP, iDefendingPlayer, iDefendingUnit, defenderDamage, defenderFinalDamage, defenderMaxHP, iInterceptingPlayer, iInterceptingUnit, interceptorDamage, iX, iY)
	local pAttackingPlayer = Players[iAttackingPlayer]
	local pDefendingPlayer = Players[iDefendingPlayer]

	if pAttackingPlayer == nil or pDefendingPlayer == nil then return end
	if defenderDamage < 1 then return end
	if pAttackingPlayer:GetCivilizationType() == eCivilizationFrance then
	
		print("When Frenchies attack")
		local pAttackingUnit = pAttackingPlayer:GetUnitByID(iAttackingUnit)
		local pDefendingUnit = pDefendingPlayer:GetUnitByID(iDefendingUnit)
		local iEspritDeCorpsUnit = pAttackingUnit:GetMultiAttackBonus(pDefendingUnit)
		local iEspritDeCorpsCity = 0
		local pPlot = Map.GetPlot(iX, iY)
		--check if it's a city
		if pPlot:IsCity() then
			print("City Attack")
			local pCity = pPlot:GetPlotCity()
			iEspritDeCorpsCity = pAttackingUnit:GetMultiAttackBonusCity(pCity)
		end	
		
		print( iEspritDeCorpsUnit )
		print( iEspritDeCorpsCity )
		local iGain = (math.max( iEspritDeCorpsUnit, iEspritDeCorpsCity ) / 10)

		if iGain > 0 then
			pAttackingPlayer:ChangeJONSCulture(iGain)
		
			if pAttackingUnit:GetDomainType() == GameInfoTypes.DOMAIN_SEA then
				print("boat")
				pAttackingPlayer:ChangeNavalCombatExperience(iGain)
			
				if pAttackingPlayer:IsHuman() and pAttackingPlayer:IsTurnActive() then
					local vUnitPosition = PositionCalculator(pAttackingUnit:GetX(), pAttackingUnit:GetY())
					Events.AddPopupTextEvent(vUnitPosition, "[COLOR_MAGENTA]+"..iGain.."[ICON_CULTURE][ENDCOLOR]", 1)
					Events.AddPopupTextEvent(vUnitPosition, "[COLOR_GREAT_PEOPLE_STORED]+"..iGain.."[ICON_GREAT_ADMIRAL][ENDCOLOR]", 1.5)
				end
		
			else 
				print("not boat")
				pAttackingPlayer:ChangeCombatExperience(iGain)
			
				if pAttackingPlayer:IsHuman() and pAttackingPlayer:IsTurnActive() then
					local vUnitPosition = PositionCalculator(pAttackingUnit:GetX(), pAttackingUnit:GetY())
					Events.AddPopupTextEvent(vUnitPosition, "[COLOR_MAGENTA]+"..iGain.."[ICON_CULTURE][ENDCOLOR]", 1)
					Events.AddPopupTextEvent(vUnitPosition, "[COLOR_GREAT_PEOPLE_STORED]+"..iGain.."[ICON_GREAT_GENERAL][ENDCOLOR]", 1.5)
				end
			end
		end
	end
end

function PositionCalculator(i1, i2)
	return HexToWorld(ToHexFromGrid(Vector2(i1, i2)))
end

if Game.IsCivEverActive(eCivilizationFrance) then
	GameEvents.CombatResult.Add(EspritDeCorpsYieldsBonus)
end